# -*- coding: utf-8 -*- 
# @Time    : 04/04/2024 
# @Author  : nzooherd 
# @File    : purchase.py 
# @Software: Visual Studio Code

from sqlalchemy import select
from dao import BaseDao
from dao.model import Purchase


class PurchaseDao(BaseDao):
    
    model = Purchase

    @classmethod
    async def is_bought(cls, user_id: str, video_id: int) -> Purchase:
        async with cls.session() as session:
            query = select(cls.model).filter_by(user_id=user_id, video_id=video_id)
            result = await session.execute(query)
            purchase = result.scalars().first()
            if not purchase:
                return None
            session.expunge(purchase)
            return purchase

